package org.greenstone.gsdl3.gs3build.util;

public class XMLTools
{
    public static String getTag(String namespace, String label, boolean open)
    {	
	StringBuffer reply = new StringBuffer();

	reply.append("<");
	if (!open)
	    {	
		reply.append("/");
	    }
	if (namespace != null && namespace.length() > 0) {
	    reply.append(namespace);
	    reply.append(":");
	}
	reply.append(label);
	reply.append(">");
	return reply.toString();
    }

    public static String addAttribute(String tag, String attribute, String value)
    {	
	StringBuffer reply = new StringBuffer(tag);
	reply.insert(reply.length() - 1 , ' ');
	reply.insert(reply.length() - 1 , attribute);
	reply.insert(reply.length() - 1 , "=\"");
	reply.insert(reply.length() - 1 , value);
	reply.insert(reply.length() - 1 , '\"');
	return reply.toString();
    }

    public static String makeSingleton(String tag)
    {	
	StringBuffer reply = new StringBuffer(tag);
	reply.insert(tag.length() - 1, " /");
	return reply.toString();
    }
    
    public static String getOpenTag(String namespace, String label)
    {	
	return getTag(namespace, label, true);
    }
    
    public static String getCloseTag(String namespace, String label)
    {	
	return getTag(namespace, label, false);
    }

    /**
     *  Clean a string to remove whitespace...
     *
     *  @param <code>String</code> the original text
     *  @return <code>String</code> the 'cleaned' text
     */
    public static String cleanString(String original)
    {	
	StringBuffer buffer = new StringBuffer(original);

	while (buffer.charAt(0) <= 32) {
	    buffer.deleteCharAt(0);
	}
	
	while (buffer.charAt(buffer.length() - 1) <= 32){
	    buffer.deleteCharAt(buffer.length() - 1);
	}
	
	int c = 1;
	while (c < buffer.length()){
	    if (buffer.charAt(c) < 32){
		buffer.setCharAt(c, ' ');
	    }
	    if (buffer.charAt(c) == ' ' && buffer.charAt(c-1) == ' '){
		buffer.deleteCharAt(c);
		continue;
	    }
	    c ++;
	}
	return buffer.toString();
    }
}
